
import java.io.*;
import java.util.Arrays;
import java.util.Comparator;
import java.util.StringTokenizer;

/**
 * Created by YuryBandarchuk on 12.10.16.
 */
public class Main {

    private static int[] a;

    public static void main(String[] args) throws FileNotFoundException {
        InputReader in = new InputReader(System.in);
        PrintWriter out = new PrintWriter(new File("secretroom.out"));
        int n = in.nextInt();
        a = new int[n];
        Integer[] p = new Integer[n];
        int[] fw = new int[n];
        int[] val = new int[n];
        for (int i = 0; i < n; i++) {
            p[i] = i;
            fw[i] = 0;
            a[i] = in.nextInt() + i;
        }
        Arrays.sort(p, new Comparator<Integer>() {
            @Override
            public int compare(Integer o1, Integer o2) {
                return Integer.compare(a[o1], a[o2]);
            }
        });
        val[p[0]] = 0;
        int id = 0;
        for (int i = 1; i < n; i++) {
            if (a[p[i]] != a[p[i - 1]]) {
                ++id;
            }
            val[p[i]] = id;
        }
        for (int i = 0; i < n; i++) {
            int value = get(fw, val[i] - 1) + 1;
            update(fw, val[i], value);
        }
        int ans = get(fw, n - 1);
        out.println(ans);
        out.close();
    }

    static void update(int[] fw, int pos, int val) {
        while (pos < fw.length) {
            fw[pos] = Math.max(fw[pos], val);
            pos |= (pos + 1);
        }
    }

    static int get(int[] fw, int r) {
        int result = 0;
        while (r >= 0) {
            result = Math.max(result, fw[r]);
            r = (r & (r + 1)) - 1;
        }
        return result;
    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) throws FileNotFoundException {
            reader = new BufferedReader(new InputStreamReader(new FileInputStream("secretroom.in")), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }

}
