import random
random.seed("basic02/cupboard")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([1, 2, 4], [[1, 2], [1, 4], [3, 4]], 2, 1, 1)

    def generate_min_tests(self):
        self.print_test([1, 2, 4], [[1, 2, 3, 4], [1, 2, 3, 4], [1, 2, 3, 4]], 2, 1, 1)

    def generate_hand_tests(self):
        pass

    def generate_fully_random_test(self, maxn, maxv):
        n = maxn
        hs = [0 for _ in range(n)]
        shoes = [[] for _ in range(n)]
        k = random.randint(1, 100)
        m2 = random.randint(1, 100)
        m1 = random.randint(m2, 100)
        last = 0
        for i in range(n):
            hs[i] = random.randint(last + 1, maxv - (n - i - 1))
            last = hs[i]
        for i in range(n):
            ind = random.randint(0, n - 1)
            size = random.randint(1, maxv)
            shoes[ind].append(size)
        self.print_test(hs, shoes, k, m1, m2)

    def generate_random_test(self, maxn, maxv):
        n = maxn
        hs = [0 for _ in range(n)]
        shoes = [[] for _ in range(n)]
        k = random.randint(1, 100)
        m2 = random.randint(1, 100)
        m1 = random.randint(m2, 100)
        last = 0
        for i in range(n):
            hs[i] = random.randint(last + 1, maxv - (n - i - 1))
            last = hs[i]
        for i in range(n):
            ind = random.randint(0, n - 1)
            rightB = hs[ind] * k // m2
            leftB = (hs[ind] + m1 - 1) // m1
            if leftB > rightB:
                shoes[ind].append(random.randint(1, maxv))
                continue
            if random.randint(1, 2) == 1:
                shoes[ind].append(min(maxv, random.randint(leftB, rightB)))
            else:
                if leftB > 1 and random.randint(1, 2) == 1:
                    shoes[ind].append(random.randint(1, leftB - 1))
                else:
                    if rightB + 1 > maxv:
                        shoes[ind].append(min(maxv, random.randint(leftB, rightB)))
                    else:
                        shoes[ind].append(random.randint(rightB + 1, maxv))
        self.print_test(hs, shoes, k, m1, m2)

    def generate_max_tests(self, maxn, maxv):
        pass

    def print_test(self, hs, shoes, k, m1, m2):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(len(shoes), file=test_file)
        print(k, m1, m2, file=test_file)
        for i, shoe in enumerate(shoes):
            print(hs[i], end='', file=test_file)
            if len(shoe) == 0:
                print(' 0', file=test_file)
            else:
                print(' ' + str(len(shoe)) + ' ' + ' '.join(map(str, shoe)), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [10, 50, 100, 10**3, 10**4, 10**5]
        maxvs = [100, 1000, 10**5, 10**7]
        for n in ns:
            for maxv in maxvs:
                if maxv < n:
                    continue
                self.generate_fully_random_test(n, maxv)
                self.generate_random_test(n, maxv)
        self.generate_max_tests(10**5, 10**7)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
