#include "testlib.h"
#include <vector>

using namespace std;

typedef long long ll;
const int MAX_N = 100000;
const int MAX_V = 100000000;

ll x[MAX_N], y[MAX_N], mx, my;

ll cross(ll x1, ll y1, ll x2, ll y2)
{
	return x1*y2 - x2*y1;
}

int main()
{
    registerValidation();

    int n = inf.readInt(3, MAX_N, "n");
    inf.readEoln();
	for (int i = 0; i < n; ++i)
	{
		x[i] = inf.readInt(-MAX_V, MAX_V, "x_i");
		inf.readSpace();
		y[i] = inf.readInt(-MAX_V, MAX_V, "y_i");
		inf.readEoln();
	}
	mx = inf.readInt(-MAX_V, MAX_V, "mx");
	inf.readSpace();
	my = inf.readInt(-MAX_V, MAX_V, "my");
	inf.readEoln();
	inf.readEof();
	
	for (int i = 0; i < n; ++i)
	{
		int i1 = (i + 1) % n;
		int i2 = (i + 2) % n;
        ensuref(cross(x[i1] - x[i], y[i1] - y[i], x[i2] - x[i], y[i2] - y[i]) > 0, "the polygon should be convex");
	}
	for (int i = 0; i < n; ++i)
	{
		int i1 = (i + 1) % n;
        ensuref(cross(x[i1] - x[i], y[i1] - y[i], mx - x[i], my - y[i]) > 0, "m must be inside the polygon");
	}
	
    return 0;
}
