#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME "mirror"

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const double eps = 1e-8;

struct point {
    double x, y;
    point() {
        x = y = 0;
    }
    point(double _x, double _y) {
        x = _x;
        y = _y;
    }
    double operator*(point p) {
        return x * p.y - y * p.x;
    }
    double operator/(point p) {
        return x * p.x + y * p.y;
    }
    point operator*(double num) {
        return point(num * x, num * y);
    }
    point operator+(point p) {
        return point(x + p.x, y + p.y);
    }
    point operator-(point p) {
        return point(x - p.x, y - p.y);
    }
};

struct line {
    double a, b, c;
    line() {
        a = c = 0;
        b = 1;
    }
    void normalize() {
        double tmp = sqrt(a * a + b * b);
        a /= tmp;
        b /= tmp;
        c /= tmp;
    }
    line(point p1, point p2) {
        a = (p1.y - p2.y);
        b = (p2.x - p1.x);
        c = -(a * p1.x + b * p1.y);
        //assert(fabs(a * p2.x + b * p2.y + c) < eps);
        normalize();
    }
    double dist(point p) {
        return p.x * a + p.y * b + c;
    }
};

point intersect(line l1, line l2) {
    point ret = point((-l1.c * l2.b + l1.b * l2.c) / (l1.a * l2.b - l2.a * l1.b), (-l1.a * l2.c + l1.c * l2.a) / (l1.a * l2.b - l2.a * l1.b));
    //assert(fabs(l1.dist(ret)) < eps && fabs(l2.dist(ret)) < eps);
    return ret;
}

vector<point> inp;
vector<double> prefs;
point center;
int n;

double get_sq(int from, int to) {
    if (from > to) {
        to += n;
    }
    //cerr << prefs[to] << " " << prefs[from] << " " << inp[to % n] * inp[from % n] << endl;
    return (prefs[to] - prefs[from] + inp[to % n] * inp[from % n]) / 2;
}

double solve(int side) {
    line ls = line(inp[side], inp[(side + 1) % n]);
    point ort = point(ls.a, ls.b);
    point nc = center - ort * ls.dist(center) * 2;

    //cerr << nc.x << " " << nc.y << endl;

    double ans = get_sq(0, n - 1);
    //cerr << ans << endl;

    line l1 = line(nc, inp[side]);
    line l2 = line(nc, inp[(side + 1) % n]);
    int l = (side + 1) % n, r = l + n - 1;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (l2.dist(inp[mid % n]) * l2.dist(inp[side]) <= 0) {
            l = mid;
        } else {
            r = mid;
        }
    }
    //cerr << l << endl;
    ans -= get_sq((side + 1) % n, l);
    point intr = intersect(l2, line(inp[l % n], inp[(l + 1) % n]));
    
    ans -= fabs((inp[l % n] - inp[(side + 1) % n]) * (intr - inp[(side + 1) % n]) / 2);

    l = (side + 1), r = side + n;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (l1.dist(inp[mid % n]) * l1.dist(inp[(side + 1) % n]) >= 0) {
            l = mid;
        } else {
            r = mid;
        }
    }
    //cerr << r << endl;
    ans -= get_sq(r, side + n);
    intr = intersect(l1, line(inp[r % n], inp[(r - 1 + n) % n]));
    //cerr << intr.x << " " << intr.y << endl;
    ans -= fabs((intr - inp[side]) * (inp[r % n] - inp[side]) / 2);

    return ans;
}

int main() {
    freopen(TASK_NAME ".in", "r", stdin);
    freopen(TASK_NAME ".out", "w", stdout);

    scanf("%d", &n);

    for (int i = 0; i < n; ++i) {
        int x, y;
        scanf("%d%d", &x, &y);
        inp.puba(point(x, y));
    }

    int x, y;
    scanf("%d%d", &x, &y);
    center = point(x, y);
    
    prefs.puba(0);

    for (int i = 0; i < n * 2; ++i) {
        prefs.puba(prefs.back() + inp[i % n] * inp[(i + 1) % n]);
    }

    /*
    for (auto val: prefs) {
        cerr << val << endl;
    }*/

    for (int i = 0; i < n; ++i) {
        printf("%.10f\n", solve(i));
    }

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}