#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1 << 20;

int n, m;
vector<int> tp;
vector<int> l, r, id;
vector<string> s;
char buf[MAXN];
string all;

struct node {
    int add;
    node *l, *r;

    node(node *_l, node *_r) {
        add = 0;
        l = _l;
        r = _r;
    };

    node(node *old, node *_l, node *_r, int nadd) {
        add = old->add + nadd;
        l = _l;
        r = _r;
    }
};

node* build(int tl, int tr) {
    if (tl == tr) return new node(0, 0);
    int tm = (tl + tr) >> 1;
    return new node(build(tl, tm), build(tm + 1, tr));
}

node* add(node *t, int tl, int tr, int l, int r, int delta) {
    if (l > r) return t;
    if (l == tl && r == tr) return new node(t, t->l, t->r, delta);
    int tm = (tl + tr) >> 1;
    return new node(t, add(t->l, tl, tm, l, min(r, tm), delta), add(t->r, tm + 1, tr, max(l, tm + 1), r, delta), 0);
}

int get(node *t, int tl, int tr, int x) {
    int ans = 0;
    while (tl != tr) {
        ans += t->add; 
        int tm = (tl + tr) >> 1;
        if (x <= tm) tr = tm, t = t->l;
        else tl = tm + 1, t = t->r;
    }
    ans += t->add;
    return ans;
}

int main() {
    freopen("stringsqueries.in", "r", stdin);
    freopen("stringsqueries.out", "w", stdout);

    scanf("%d%d", &n, &m);
    tp.resize(m);
    l.resize(m);
    r.resize(m);
    id.resize(m);
    s.resize(m);
    for (int i = 0; i < m; i++) {
        scanf("%d", &tp[i]);
        if (tp[i] == 1) {
            scanf("%d%d%s", &l[i], &r[i], buf);
            s[i] = buf;
        }
        if (tp[i] == 2) {
            scanf("%d%d%d", &id[i], &l[i], &r[i]);
            id[i]--;
        }
        l[i]--; r[i]--;
    }

    vector<node*> roots;
    roots.push_back(build(0, n - 1));
    for (int i = 0; i < m; i++) {
        if (tp[i] == 1) {
            for (int j = 0; j < (int)s[i].length(); j++) {
                all += s[i][j];
                roots.push_back(add(roots.back(), 0, n - 1, l[i], r[i], 1));
            }
        }
    }
    for (int i = 0; i < m; i++) {
        if (tp[i] == 2) {
            string ans;
            for (int j = l[i]; j <= r[i]; j++) {
                int L = -1, R = (int)roots.size();
                while (R - L > 1) {
                    int M = (L + R) >> 1;
                    if (get(roots[M], 0, n - 1, id[i]) >= j + 1) R = M;
                    else L = M;
                }
                ans += all[R - 1];
            } 
            printf("%s\n", ans.c_str());
        }
    }

    return 0;
}
